"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var webpack_1 = require("webpack");
var path_1 = require("path");
var process_1 = require("process");
var getWebpackConfig_1 = __importDefault(require("../getWebpackConfig"));
var getDataverseConfig_1 = __importDefault(require("../getDataverseConfig"));
var resolveLocalAsset_1 = require("../../assets/resolveLocalAsset");
var promises_1 = require("fs/promises");
var createWebFileLoader_1 = __importDefault(require("../../assets/createWebFileLoader"));
function buildCompiler() {
    var _this = this;
    var dataverseConfig = getDataverseConfig_1.default();
    var config = getWebpackConfig_1.default();
    var entry = {};
    for (var _i = 0, _a = Object.keys(dataverseConfig.assets); _i < _a.length; _i++) {
        var srcFile = _a[_i];
        entry[srcFile] = path_1.resolve(dataverseConfig.srcPath, srcFile);
    }
    config.entry = entry;
    var destinationAssetMap = {};
    config.output = {
        filename: function (pathData, assetInfo) {
            var fileName = pathData.runtime;
            var assetName = dataverseConfig.assets[fileName];
            var asset = resolveLocalAsset_1.resolveLocalAsset(dataverseConfig.portalPath, assetName);
            destinationAssetMap[asset.contentFilePath] = asset;
            return asset.contentFilePath;
        },
        path: process_1.cwd(),
    };
    var compiler = webpack_1.webpack(config);
    compiler.hooks.assetEmitted.tapPromise("dataverse", function (filePath, info) { return __awaiter(_this, void 0, void 0, function () {
        var content, _a, entityLogicalName, id, portalName, webFileName, webFilePath;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    content = info.content.toString();
                    if (!(content.length > 100000)) return [3 /*break*/, 2];
                    _a = destinationAssetMap[filePath], entityLogicalName = _a.entityLogicalName, id = _a.id, portalName = _a.portalName;
                    webFileName = entityLogicalName + "_" + id + ".js";
                    webFilePath = path_1.join(dataverseConfig.portalPath, portalName, "web-files", webFileName);
                    return [4 /*yield*/, Promise.all([
                            promises_1.writeFile(filePath, createWebFileLoader_1.default(webFileName)),
                            promises_1.writeFile(webFilePath, content),
                        ])];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2: return [2 /*return*/];
            }
        });
    }); });
    return compiler;
}
exports.default = buildCompiler;
