"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var webpack_1 = require("webpack");
var path_1 = require("path");
var fs_1 = require("fs");
function getWebpackConfig() {
    var webpackConfigPath = path_1.resolve(process.cwd(), "./webpack.config.js");
    if (fs_1.existsSync(webpackConfigPath)) {
        return require(webpackConfigPath);
    }
    else {
        var defaultConfig = webpack_1.config.getNormalizedWebpackOptions({});
        webpack_1.config.applyWebpackOptionsDefaults(defaultConfig);
        return defaultConfig;
    }
}
exports.default = getWebpackConfig;
