"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var authentication_1 = require("../../api/authentication");
var buildCompiler_1 = __importDefault(require("./buildCompiler"));
var getDataverseConfig_1 = __importDefault(require("../getDataverseConfig"));
var attachDataverseConfigToCompiler_1 = __importDefault(require("./attachDataverseConfigToCompiler"));
var webpack_dev_middleware_1 = __importDefault(require("webpack-dev-middleware"));
function serve() {
    var dataverseConfig = getDataverseConfig_1.default(true);
    var compiler = buildCompiler_1.default(dataverseConfig);
    authentication_1.authenticate(dataverseConfig);
    attachDataverseConfigToCompiler_1.default(dataverseConfig, compiler);
    webpack_dev_middleware_1.default(compiler);
}
exports.default = serve;
