"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var find_1 = require("find");
var path_1 = require("path");
function findFile(path) {
    var parts = path.split(/[/\\]/);
    var fileName = parts.pop();
    if (parts[0] !== ".") {
        parts.unshift(".");
    }
    var folderPath = path_1.join.apply(void 0, parts);
    var files = find_1.fileSync(new RegExp("^(.*[/\\\\])?" + fileName.replace(".", "\\.") + "$", "i"), folderPath);
    if (files.length === 0) {
        throw new Error("Could not find file: " + path);
    }
    else if (files.length > 1) {
        throw new Error("Found multiple files with path: " + path);
    }
    else {
        return files[0];
    }
}
exports.default = findFile;
